<style>
  .round {
      font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
      border-radius: 50%;
  }
</style>
<!-- Nav Item - User Information -->
<li class="nav-item dropdown no-arrow mx-1">
  <a class="nav-link">
      <i class="vatsim-rating {{current_user.atc_rating.lower()}}"></i>
      {% for rating in current_user.pilot_ratings %}
        <i class="fa-fw vatsim-rating {{rating.lower()}}"></i>
      {% endfor %}
  </a>
</li>
<div class="topbar-divider d-none d-sm-block"></div>
<li class="nav-item dropdown no-arrow">
  <a class="nav-link dropdown-toggle" href="#" id="userDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
      <span class="mr-2 d-none d-lg-inline text-gray-600 small">{{current_user.cid}} - {{current_user.name}}</span>
      <img class="round" width="42" height="42" avatar="{{ current_user.name }}">
  </a>
  <!-- Dropdown - User Information -->
  <div class="dropdown-menu dropdown-menu-right shadow animated--grow-in" aria-labelledby="userDropdown">
      <a class="dropdown-item" href="{{ url_for('profile') }}">
      <i class="fas fa-user fa-sm fa-fw mr-2 text-gray-400"></i>
      Profile
      </a>
      <div class="dropdown-divider"></div>
      <a class="dropdown-item"
        href="#"
        data-toggle="modal"
        data-target="#registerTeamspeakModal">Teamspeak Registration</a>
      <div class="dropdown-divider"></div>
      <a class="dropdown-item"
        href="#"
        data-toggle="modal"
        data-target="#registerDiscordModal">Discord Registration</a>
      <div class="dropdown-divider"></div>
      <a class="dropdown-item" href="#" data-toggle="modal" data-target="#logoutModal">
      <i class="fas fa-sign-out-alt fa-sm fa-fw mr-2 text-gray-400"></i>
      Logout
      </a>
  </div>
</li>

<!-- registerTeamspeakModal Modal-->
<form id="registerTeamspeakForm" action="{{url_for('teamspeak.register', cid=current_user.cid)}}" method="POST">
  <div class="modal fade" id="registerTeamspeakModal" tabindex="-1" role="dialog" aria-labelledby="registerTeamspeakModalLabel" aria-hidden="true">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="registerTeamspeakModalLabel">TeamSpeak3 Account Resgistration</h5>
                <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
            </div>
            <div style="margin:20px">
                <p>For register on Teamspeak you must login first onto the server:</p>
                <div style="margin:20px">
                    <code>
                        <b>
                            <p>Server: ts.portugal-vacc.org</p>
                            <p>Port: Leave blank</p>
                            <p>Nickname: {{current_user.name}}</p>
                        </b>
                    </code>
                </div>
                <p>After logging in you will be in the Entrance room.</p>
                <p>Now you can click <b><i>Perform Registration</i></b>.</p>
            </div>
            <div class="modal-footer">
              <button class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
              <input  class="btn btn-primary" style="color: #f8f9fc;" type="submit" value="Perform Registration"></input>
            </div>
        </div>
      </div>
  </div>
</form>
<!-- registerDiscordModal Modal-->
<div class="modal fade" id="registerDiscordModal" tabindex="-1" role="dialog" aria-labelledby="registerDiscordModalLabel" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title" id="registerDiscordModalLabel">Discord Account Resgistration</h5>
            <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">×</span>
            </button>
        </div>
        <div style="margin:20px">
            <p>For register on Discord follow next steps:</p>
            <div style="margin:20px">
                <code>
                    <b>
                        <p>Join Server: <a href="https://discord.gg/hHgwzRf">https://discord.gg/hHgwzRf</a></p>
                        <p>Execute this command on discord:</p>
                        !vacc-registerme {{ discord_reg_token }}
                    </b>
                </code>
            </div>
        </div>
        <div class="modal-footer">
        <button class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
        </div>
    </div>
  </div>
</div>
<!-- VATSIM CLIENT Modal-->

<div class="modal fade" id="clientEventModal" tabindex="-1" role="dialog" aria-labelledby="clientEventModalLabel" aria-hidden="true">
  <div class="modal-dialog" role="document">
      <div class="modal-content">
      <div class="modal-header">
          <h5 class="modal-title" id="clientEventModalLabel">Do you want delete this event?</h5>
          <button class="close" type="button" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">×</span>
          </button>
      </div>
      <div class="modal-body">
          <!--Google map-->
          <div id="googleMap" style="width:100%;height:400px;"></div>
      </div>
      </div>
  </div>
</div>
<script src="{{ url_for('static', filename='js/atcpolygons.js') }}"></script>
<script>
  function myMap(center, marker, line) {
      var mapProp= {
          center:center,
          zoom:4,
          mapTypeId: 'satellite'
      };
      var map = new google.maps.Map(document.getElementById("googleMap"),mapProp);
      if(marker){
          marker.setMap(map);
      }
      if(line){
          line.setMap(map)
      }
  }
  function check_vatsim_conn(){
      const xhr = new XMLHttpRequest();
      xhr.open('GET', 'https://vatsim-api.flyatlantic-va.com/clients?where=cid=="{{current_user.cid}}"', true);
      xhr.onload = function () {
          const result = JSON.parse(xhr.response)['_items'];
          if (result.length > 0){
              document.getElementById('online_text').innerText = "Online as " + result[0].callsign + " (" + result[0].clienttype + ")"
              document.getElementById('clientEventModalLabel').innerText = result[0].callsign + " from " + result[0].planned_depairport + " to " + result[0].planned_destairport
              var btn = document.getElementById('btnonlinestatus')
              btn.style = "color:green; background-color: transparent; border: none;"
              if(result[0].clienttype == 'PILOT'){
                  var client_position = new google.maps.LatLng(result[0].location[1], result[0].location[0])
                  var symbol = {
                      path: 'M362.985,430.724l-10.248,51.234l62.332,57.969l-3.293,26.145 l-71.345-23.599l-2.001,13.069l-2.057-13.529l-71.278,22.928l-5.762-23.984l64.097-59.271l-8.913-51.359l0.858-114.43 l-21.945-11.338l-189.358,88.76l-1.18-32.262l213.344-180.08l0.875-107.436l7.973-32.005l7.642-12.054l7.377-3.958l9.238,3.65 l6.367,14.925l7.369,30.363v106.375l211.592,182.082l-1.496,32.247l-188.479-90.61l-21.616,10.087l-0.094,115.684',
                      fillColor: '#FF0000',
                      fillOpacity: 1.0,
                      anchor: new google.maps.Point(result[0].location[1], result[0].location[0]),
                      strokeWeight: 0,
                      scale: 0.05,
                      rotation: Number(result[0].heading)
                  }
                  var marker = new google.maps.Marker({
                      position: client_position,
                      title: result[0].callsign + " - " + result[0].realname,
                      icon: symbol
                  });

                  var route = Array()
                  result[0].location_history['coordinates'].forEach(element => {
                      route.push({
                          lat:element[1],
                          lng:element[0]
                      })
                  });

                  var line = new google.maps.Polyline({
                      path: route,
                      geodesic: true,
                      strokeColor: '#FF0000',
                      strokeOpacity: 1.0,
                      strokeWeight: 2
                  });
                  myMap(
                      client_position,
                      marker,
                      line)
              }
              if(result[0].clienttype == 'ATC'){
                  var client_position = new google.maps.LatLng(result[0].location[1], result[0].location[0])
                  var coords = POLYGONS[result[0].callsign]['coordinates']
                  var marker = new google.maps.Polygon({
                          paths: coords,
                          strokeColor: '#FF0000',
                          strokeOpacity: 0.8,
                          strokeWeight: 2,
                          fillColor: '#FF0000',
                          fillOpacity: 0.35
                      });

                  myMap(
                      client_position,
                      marker,
                      null)
              }
          }
          else{
              var btn = document.getElementById('btnonlinestatus')
              var text = document.getElementById('online_text')
              text.innerText = "Disconnected from VATSIM"
              btn.style = "color:blue; background-color: transparent; border: none;"
              btn.dataset.target=""
          }
      }
      xhr.send(null);
  }
  this.check_vatsim_conn()

  setInterval(function() {
      this.check_vatsim_conn()
  }, 60 * 1000); // 60 seg

  (function(w, d){


      function LetterAvatar (name, size) {

          name  = name || '';
          size  = size || 60;

          var colours = [
                  "#1abc9c", "#2ecc71", "#3498db", "#9b59b6", "#34495e", "#16a085", "#27ae60", "#2980b9", "#8e44ad", "#2c3e50",
                  "#f1c40f", "#e67e22", "#e74c3c", "#ecf0f1", "#95a5a6", "#f39c12", "#d35400", "#c0392b", "#bdc3c7", "#7f8c8d"
              ],

              nameSplit = String(name).toUpperCase().split(' '),
              initials, charIndex, colourIndex, canvas, context, dataURI;


          if (nameSplit.length == 1) {
              initials = nameSplit[0] ? nameSplit[0].charAt(0):'?';
          } else {
              initials = nameSplit[0].charAt(0) + nameSplit[1].charAt(0);
          }

          if (w.devicePixelRatio) {
              size = (size * w.devicePixelRatio);
          }

          charIndex     = (initials == '?' ? 72 : initials.charCodeAt(0)) - 64;
          colourIndex   = charIndex % 20;
          canvas        = d.createElement('canvas');
          canvas.width  = size;
          canvas.height = size;
          context       = canvas.getContext("2d");

          context.fillStyle = colours[colourIndex - 1];
          context.fillRect (0, 0, canvas.width, canvas.height);
          context.font = Math.round(canvas.width/2)+"px Arial";
          context.textAlign = "center";
          context.fillStyle = "#FFF";
          context.fillText(initials, size / 2, size / 1.5);

          dataURI = canvas.toDataURL();
          canvas  = null;

          return dataURI;
      }

      LetterAvatar.transform = function() {

          Array.prototype.forEach.call(d.querySelectorAll('img[avatar]'), function(img, name) {
              name = img.getAttribute('avatar');
              img.src = LetterAvatar(name, img.getAttribute('width'));
              img.removeAttribute('avatar');
              img.setAttribute('alt', name);
          });
      };


      // AMD support
      if (typeof define === 'function' && define.amd) {

          define(function () { return LetterAvatar; });

      // CommonJS and Node.js module support.
      } else if (typeof exports !== 'undefined') {

          // Support Node.js specific `module.exports` (which can be a function)
          if (typeof module != 'undefined' && module.exports) {
              exports = module.exports = LetterAvatar;
          }

          // But always support CommonJS module 1.1.1 spec (`exports` cannot be a function)
          exports.LetterAvatar = LetterAvatar;

      } else {

          window.LetterAvatar = LetterAvatar;

          d.addEventListener('DOMContentLoaded', function(event) {
              LetterAvatar.transform();
          });
      }

  })(window, document);
</script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyDj4y39JAORYGw4rNcA1y8oVj0m8lNDje4&callback=myMap"></script>
